//
// JTLT - a templating system for the java language
// Copyright (C) 2001-2003 Indrek Mandre <indrek@mare.ee>
// All rights reserved.
//
// See the file "AUTHORS" for the name of all copyright holders.
//
// This program is free software; you can redistribute it and/or modify it
// under the terms of the GNU Lesser General Public License as published
// by the Free Software Foundation; either version 2.1 of the License, or
// (at your option) any later version.
//
// This program is distributed in the hope that it will be useful, but
// WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
// Lesser General Public License for more details.
//
// You should have received a copy of the GNU Lesser General Public
// License along with this program in the file "COPYING-LESSER"; if not,
// write to the Free Software Foundation, Inc., 59 Temple Place,
// Suite 330, Boston, MA  02111-1307  USA
//
// For more information and latest updates please see
// http://www.mare.ee/indrek/jtlt/
//

package ee.mare.indrek.jtlt;

/** Interface for querying template parameters at a specific block level.
  * This interface is usually passed to macros.
  * @see TemplateMacro*/
public interface TemplateParams {
  /** Query for a macro parameter, the scope of parameters is at the block where the macro is found.
    * @param search_parent whether to recursively search the parent blocks for the parameter
    * @see TemplateMacro
    */
  public Object findParam (String ident, boolean search_parent);

  /** Return the template context object. */
  public TemplateContext getTemplateContext ();
}

