
package ee.mare.indrek.jtlt.macros;

import ee.mare.indrek.jtlt.*;
import java.util.*;
import java.io.*;

/** A macro (ALIAS) for accessing the alias database. Uses Map named
  * as "alias_db_all" in the params. This points to the "all" map
  * inside aliases database. This macro is recursive non-parsetime. */
public class AliasMacro extends MacroAdapter {
  public AliasMacro ()
  {
    this ("ALIAS");
  }

  public AliasMacro (String name)
  {
    super (name);
  }

  public boolean isRecursive ()
  {
    return true;
  }

  public boolean isParsetime ()
  {
    return false;
  }

  public String process (TemplateParams ctx, String name, String args)
  {
    Map alias_db_all = (Map)ctx.findParam ("alias_db_all", true);
    if ( alias_db_all == null ) return "";

    String lang = (String)ctx.findParam("language", true);
    if ( lang == null ) lang = "DEFAULT";

    AliasKey ret = (AliasKey)alias_db_all.get (lang + ":" + args);
    if ( ret == null && !lang.equals ("DEFAULT") )
        ret = (AliasKey)alias_db_all.get ("DEFAULT:" + args);
    if ( ret == null ) return "";

    return ret.content;
  }
}

