// 
// JTLT - a templating system for the java language
// Copyright (C) 2001-2003 Indrek Mandre <indrek@mare.ee>
// All rights reserved.
// 
// See the file "AUTHORS" for the name of all copyright holders.
// 
// This program is free software; you can redistribute it and/or modify it
// under the terms of the GNU Lesser General Public License as published
// by the Free Software Foundation; either version 2.1 of the License, or
// (at your option) any later version.
// 
// This program is distributed in the hope that it will be useful, but
// WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
// Lesser General Public License for more details.
// 
// You should have received a copy of the GNU Lesser General Public
// License along with this program in the file "COPYING-LESSER"; if not,
// write to the Free Software Foundation, Inc., 59 Temple Place,
// Suite 330, Boston, MA  02111-1307  USA
// 
// For more information and latest updates please see
// http://www.mare.ee/indrek/jtlt/
// 

package ee.mare.indrek.jtlt.macros;

import ee.mare.indrek.jtlt.*;

/** Adapter class for easy macro creation. By default it is set to
  * parsetime, non-recursive and will return an empty string, name is specified
  * by the constructor.
  */
public class MacroAdapter implements TemplateMacro {
  private String name;

  /** Construct a simple macro with given name. */
  public MacroAdapter (String name)
  {
    this.name = name;
  }

  public boolean isParsetime ()
  {
    return true;
  }

  public boolean isRecursive ()
  {
    return false;
  }

  public String process (TemplateParams ctx, String name, String args)
  {
    return "";
  }

  public String getName ()
  {
    return name;
  }
}


